%% AOA-AS Estimation
function [AOA,AS]=AOA_AS_est(Rs,M,D,lambda,SL)

%% Number of sources estimation


%% root-MUSIC (Point source modeling)
%                     [V,D2]=eig(Rs);
%                     Q=V(:,1:(M-rank(Rs)));
%
%                     C=Q*Q';
%                     C_l=zeros(1,2*M-1);
%                     for l=-(M-1):(M-1)
%                         for m=1:M
%                             for n=1:M
%                                 if (n-m)==l
%                                     C_l(l+1+(M-1))=C_l(l+1+(M-1))+C(m,n);
%                                 end
%                             end
%                         end
%                     end
%
%                     a_roots=roots(fliplr(C_l));
%
%                     a_aux2=1;
%                     a_roots_w=zeros(1,M-1);
%                     for a_aux=1:length(a_roots)
%                         if abs((a_roots(a_aux)))<=1
%                             a_roots_w(a_aux2)=a_roots(a_aux);
%                             a_aux2=a_aux2+1;
%                         end
%                     end
%                     a_roots_w_abs=abs(a_roots_w);
%                     [Max_AOA_aux,Ind_AOA_aux]=sort(a_roots_w_abs,'descend');
%                     Ind_AOA=Ind_AOA_aux(1:rank(Rs));
%                     Max_AOA=acos(angle(a_roots_w(Ind_AOA))*(-1)/(2*pi)/(D/lambda));

%                     %[RM_f,RM_p]=rootmusic(Rs,min([rank(Rs) M-1]),'corr');
%                     %Max_AOA=acos(RM_f*(-1)/(2*pi)/(D/lambda));
%                     %Max_AOA=acos(rootmusic(Rs,2)*(-1)/(2*pi)/(D/lambda));
%                     %stem(Max_AOA*180/pi,RM_p)

%                     P_AOA=zeros(1,length(Max_AOA));
%                     for p=1:length(Max_AOA)
%                         S=exp(-1i*2*pi*D/lambda.*((0:M-1).')*cos(Max_AOA(p)));
%                         P_AOA(p)=(S'*C*S)^(-1);
%                     end
%                     stem(Max_AOA*180/pi,abs(P_AOA)) %why abs()?? Sometimes neg. values

%% Distributed source modeling

%% Pseudo-spectrum
AOA_mean_v_aux=(0:1:180)*pi/180;
AOA_mean_v=[-AOA_mean_v_aux(2) AOA_mean_v_aux pi+(pi-AOA_mean_v_aux(end-1))];
AS_v=(0:0.5:15)*pi/180;
AOA_AS=zeros(length(AOA_mean_v),length(AS_v));
for AOA_mean_aux=1:length(AOA_mean_v)
    for AS_aux=1:length(AS_v)
        R_ideal=zeros(M,M);
        for k=1:M
            for l=1:M
                R_ideal(k,l)=exp(1i*2*pi*(D/lambda)*(l-k)*cos(AOA_mean_v(AOA_mean_aux)))*exp(-0.5*(2*pi*(D/lambda)*(l-k)*AS_v(AS_aux)*sin(AOA_mean_v(AOA_mean_aux)))^2);
            end
        end
        %AOA_AS(AOA_mean_aux,AS_aux)=trace(R_ideal*Rs^(-2)*R_ideal); %% Efficient Subspace-Based Estimator for Localization of Multiple Incoherently Distributed Sources (subspaced_based.pdf)
        AOA_AS(AOA_mean_aux,AS_aux)=1/max(abs(eig((Rs^(-1))*R_ideal))); %% A Generalized Capon Estimator for Localization of Multiple Spread Sources
    end
end
[AOA_meshgrid,AS_meshgrid]=meshgrid(AOA_mean_v,AS_v);
% surf(AOA_meshgrid'*180/pi,AS_meshgrid'*180/pi,10*log10(AOA_AS))
% xlabel('AOA [degree]')
% ylabel('AS [degree]')
% zlabel('Generalized Capon pseudo-spectrum [dB]')
% title('AOA and AS estimator')

%% Local Max.
AOA_AS_sol=-Inf*ones(length(AOA_mean_v)*length(AS_v),3);
AOA_AS_sol_aux=1;
for k=1+1:length(AOA_mean_v)-1
    for l=1+1:length(AS_v)-1
        if AOA_AS(k,l)>=AOA_AS(k,l-1) && AOA_AS(k,l)>=AOA_AS(k-1,l) && AOA_AS(k,l)>=AOA_AS(k,l+1) && AOA_AS(k,l)>=AOA_AS(k+1,l)
            AOA_AS_sol(AOA_AS_sol_aux,:)=[AOA_mean_v(k)*180/pi AS_v(l)*180/pi (AOA_AS(k,l))];
            AOA_AS_sol_aux=AOA_AS_sol_aux+1;
        end
    end
end

%% Sorting
for i=1:length(AOA_mean_v)*length(AS_v)
    if AOA_AS_sol(i,3)==-Inf
        pow_v_aux=i-1;
        break;
    end
end
pow_v=sort(AOA_AS_sol(1:pow_v_aux,3),1,'descend');
AOA_AS_sol_sort=zeros(length(pow_v),3);
used=zeros(1,length(pow_v));
used_aux=1;
for i=1:length(pow_v)
    for j=1:length(pow_v)
        if sum(used==j)==0
            if AOA_AS_sol(j,3)==pow_v(i)
                AOA_AS_sol_sort(i,:)=AOA_AS_sol(j,:);
                used(used_aux)=j;
                used_aux=used_aux+1;
                break;
            end
        end
    end
end

%% Eliminate "side" peaks
AOA_AS_sol_group=zeros(length(pow_v),length(pow_v));
angle_res=2;
for i=1:length(pow_v)
    AOA_AS_sol_group(i,1)=i;
    AOA_i=AOA_AS_sol_sort(i,1);
    AS_i=AOA_AS_sol_sort(i,2);
    AOA_AS_sol_group_aux=2;
    for j=i+1:length(pow_v)
        AOA_j=AOA_AS_sol_sort(j,1);
        AS_j=AOA_AS_sol_sort(j,2);
        if sqrt((AOA_i-AOA_j)^2+(AS_i-AS_j)^2)<=angle_res
            AOA_AS_sol_group(i,AOA_AS_sol_group_aux)=j;
            AOA_AS_sol_group_aux=AOA_AS_sol_group_aux+1;
        end
    end
end

AOA_AS_sol_group2=[AOA_AS_sol_group zeros(length(pow_v),(length(pow_v)^2)-length(pow_v))];
while (1)
    for i=1:length(pow_v)
        if AOA_AS_sol_group2(i,1)~=0
            for j=1:length(pow_v)^2
                if AOA_AS_sol_group2(i,j)~=0
                    if sum(sum((AOA_AS_sol_group2(i+1:end,:)==AOA_AS_sol_group2(i,j))))~=0
                        [row,col]=find(AOA_AS_sol_group2(i+1:end,:)==AOA_AS_sol_group2(i,j));
                        row=row+i;
                        for k=1:length(pow_v)^2
                            if AOA_AS_sol_group2(row(1),k)==0
                                row_max_new=k-1;
                                break;
                            end
                        end
                        for k=1:length(pow_v)^2
                            if AOA_AS_sol_group2(i,k)==0
                                row_max_new=k;
                                break;
                            end
                        end
                        AOA_AS_sol_group2(i,k:k+row_max_new-1)=AOA_AS_sol_group2(row(1),1:row_max_new);
                        AOA_AS_sol_group2(row(1),1:row_max_new)=zeros(1,row_max_new);
                    end
                else
                    break;
                end
            end
        end
    end
    
    while_aux=0;
    for i=1:length(pow_v)
        if AOA_AS_sol_group2(i,1)~=0
            for j=1:length(pow_v)^2
                if AOA_AS_sol_group2(i,j)~=0
                    if sum(sum((AOA_AS_sol_group2(i+1:end,:)==AOA_AS_sol_group2(i,j))))~=0
                        while_aux=1;
                        break;
                    end
                else
                    break;
                end
            end
            if while_aux==1
                break;
            end
        end
    end
    if while_aux==0
        break;
    end
end

AOA_AS_sol_group3=zeros(length(pow_v),length(pow_v)^2);
AOA_AS_sol_group3_row=0;
AOA_AS_sol_group3_col=0;
for i=1:length(pow_v)
    AOA_AS_sol_group3_col=0;
    if AOA_AS_sol_group2(i,1)~=0
        AOA_AS_sol_group3_row=AOA_AS_sol_group3_row+1;
        for k=1:length(pow_v)^2
            if AOA_AS_sol_group2(i,k)==0
                break;
            end
            if sum(AOA_AS_sol_group3(AOA_AS_sol_group3_row,:)==AOA_AS_sol_group2(i,k))==0
                AOA_AS_sol_group3_col=AOA_AS_sol_group3_col+1;
                AOA_AS_sol_group3(AOA_AS_sol_group3_row,AOA_AS_sol_group3_col)=AOA_AS_sol_group2(i,k);
            end
        end
    end
end

%% Maximum power
AOA_AS_sol_sort2=zeros(AOA_AS_sol_group3_row,3);
for i=1:AOA_AS_sol_group3_row
    for k=1:length(pow_v)^2
        if AOA_AS_sol_group3(i,k)==0
            row_max_new=k-1;
            break;
        end
    end
    sort_M_aux=AOA_AS_sol_group3(i,1:row_max_new);
    sort_M=AOA_AS_sol_sort(sort_M_aux,:);
    [maxi,row]=max(sort_M(:,3));
    sort2_aux=sort_M_aux(row(1));
    AOA_AS_sol_sort2(i,:)=AOA_AS_sol_sort(sort2_aux,:);
end

%% Pick M highest peaks
AOA_AS_sol_final=AOA_AS_sol_sort2(1:SL,:);

AOA=AOA_AS_sol_final(:,1);
AS=AOA_AS_sol_final(:,2);